#!/bin/sh
#
#       License: GPLv2
#       Author: review (http://www.mobileread.com/forums/member.php?u=88891)
#       Author: fortwienix (http://www.mobileread.com/forums/member.php?u=109732)
#
/ebrmain/bin/netagent connect
cd /mnt/ext1
agency=SuedeutscheZeitung-$(date +%Y-%m-%d).html

# temp dir where to store all downloaded files
if [ -d myrss-tmp ]; then 
	rm -rf myrss-tmp;
fi
mkdir myrss-tmp;
cd myrss-tmp;

# where is the progressbar app?
if [ -e /mnt/ext1/applications/tools/progressb.app ]; then
  PRG_APP=/mnt/ext1/applications/tools/progressb.app
fi
if [ -e ../progressb.app ]; then
  PRG_APP=../progressb.app
fi

echo '<html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"/></head><body>' > $agency

echo "0" > percent

wget -O feed http://www.sueddeutsche.de/app/service/rss/alles/rss.xml
cat feed|
sed 's|<title>|\n<title>|g;s|</link>|</link>\n|g' |grep "<link>" > feed2
if [ ! -z $PRG_APP ]; then
	tail -f percent| $PRG_APP &
fi
total=$(grep -c ^ feed2)
current=0
cat feed2|
while read line; do
        current=$((current+1))
        echo $current $total|awk '{printf "%.0f\n",$1*100/$2}' >> percent
        
        link=$(echo $line | sed 's|.*<link>\(.*\)</link>|\1|')
        title=$(echo $line | sed 's|<title>\(.*\)</title>.*|\1|')
        
        reallink=$(echo "$link" | grep rssfeed)
        if [ "$reallink " == " " ]; then
           continue;
        fi
        
	rm article-raw
	wget -O article-raw "$link";
	printurl=$(cat article-raw |grep 'title="Artikel drucken"' | sed 's/.*href="\([^"]*\).*/\1/')
	rm article-raw
	wget -O article-raw "$printurl";
	begin=$(cat article-raw |grep -n 'div class="body"' |head -1|awk -F: '{print $1}')
	end=$(cat article-raw |grep -n 'div class="footer"'|head -1|awk -F: '{print $1}')
	if [ "$begin " = " " ] && [ "$end " = " " ]; then
		continue
	fi
	end=$((end-1))
	begin=$((end-begin))
	# the seds below are just to tidy up the toc of fbreader.
	echo "<h1>$title</h1>" >>$agency
	cat article-raw | head -n $end | tail -n $begin | sed 's|<h[1-5]>|<br/><b>|g;s|</h[1-5]>|</b><br/>|g' >> $agency
done
echo "100" >> percent
echo '</body></html>' >> $agency
mv $agency ../.
cd ..
rm -rf myrss-tmp
/ebrmain/bin/netagent disconnect
